Subject: Re: [Technical Errata Reported] RFC4443 (6153)

From: Töma Gavrichenkov <[email-masked]>
Date: Mon, 22 Feb 2021 23:40:23 +0300

Folks.

On Fri, Nov 27, 2020, 11:37 PM Töma Gavrichenkov <[email-masked]> wrote:

> On Fri, May 1, 2020 at 2:04 PM RFC Errata System
> <[email-masked]> wrote:
> > The following errata report has been submitted for RFC4443,
> > "Internet Control Message Protocol (ICMPv6) for the Internet Protocol
> Version 6 (IPv6) Specification".
>
> (removing dead email addresses)
> Any other opinions?
>

It's been quite a while, isn't it?

--
Töma

---

From: Ole Troan <[email-masked]>
Date: Mon, 22 Feb 2021 21:50:33 +0100

Töma,

I have read your errata. 
I am not  sure I understand the ambiguity. Could you try to explain it in more detail?

Cheers 
Ole

> On 22 Feb 2021, at 21:41, Töma Gavrichenkov <[email-masked]> wrote:
> 
> 
> Folks.
> 
>> > "Internet Control Message Protocol (ICMPv6) for the Internet Protocol Version 6 (IPv6) Specification".
>> 
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------

---

From: Töma Gavrichenkov <[email-masked]>
Date: Tue, 23 Feb 2021 00:22:37 +0300

Peace,

On Mon, Feb 22, 2021, 11:50 PM Ole Troan <[email-masked]> wrote:

> Töma,
>
> I have read your errata.
> I am not  sure I understand the ambiguity. Could you try to explain it in
> more detail
>

Consider a case when the source IP is link-local and the destination is
global, yet the routing happens in the same VLAN.

Per RFC 4007, the packet should be transmitted; however, RFC 4443 allows
for an ambiguity which is already causing vendors to reject packets in this
case.

--
Töma

---

From: Ole Troan <[email-masked]>
Date: Mon, 22 Feb 2021 22:41:35 +0100

Töma,

It’s perfectly valid to send a packet with a link-local source and a global destination address, as long as the interface with the global address is on the same link.

So, what’s the ambiguity?

Cheers 
Ole

> On 22 Feb 2021, at 22:22, Töma Gavrichenkov <[email-masked]> wrote:
> 
> 
> Peace,
> 
>> I am not  sure I understand the ambiguity. Could you try to explain it in more detail
> 
> 
> Consider a case when the source IP is link-local and the destination is global, yet the routing happens in the same VLAN.
> 
> Per RFC 4007, the packet should be transmitted; however, RFC 4443 allows for an ambiguity which is already causing vendors to reject packets in this case.
> 
> --
> Töma

---

From: Töma Gavrichenkov <[email-masked]>
Date: Tue, 23 Feb 2021 01:11:56 +0300

Peace,

On Tue, Feb 23, 2021, 12:41 AM Ole Troan <[email-masked]> wrote:

> It’s perfectly valid to send a packet with a link-local source and a
> global destination address, as long as the interface with the global
> address is on the same link.
>

I, too, think so, but RFC 4443, Section 3.1, says that a Destination
Unreachable Message should be sent in that case.

Which some of the (famous) vendors who have read the 4443 but haven't taken
a look on the 4007 are already doing.

--
Töma

---

From: Ole Troan <[email-masked]>
Date: Mon, 22 Feb 2021 23:27:09 +0100

> On 22 Feb 2021, at 23:12, Töma Gavrichenkov <[email-masked]> wrote:
> 
> 
> Peace,
> 
> I, too, think so, but RFC 4443, Section 3.1, says that a Destination Unreachable Message should be sent in that case.
> 
> Which some of the (famous) vendors who have read the 4443 but haven't taken a look on the 4007 are already doing.

And this is in the case where both SA and DA are assigned to interfaces connected to the same link?

I struggle to see how the paragraph in 3.1 can be misinterpreted that way. Open a bug report with the vendor in question perhaps? Or name them here. 
It’s not obvious to me that the proposed text in the errata makes it clearer by introducing “scope zone”. 

Cheers 
Ole

---

From: Brian E Carpenter <[email-masked]>
Date: Tue, 23 Feb 2021 11:53:06 +1300

On 23-Feb-21 11:27, Ole Troan wrote:
>> On Tue, Feb 23, 2021, 12:41 AM Ole Troan <[email-masked] <mailto:[email-masked]>> wrote:
>>

If they are on the same link there is no layer 3 router (a.k.a. forwarding node) involved. RFC 4443 says:
"A Destination Unreachable message SHOULD be generated by a router, or
by the IPv6 layer in the originating node, in response to a packet
that cannot be delivered... If the reason for the failure to deliver is lack of a matching entry in the forwarding node's routing table, the Code field is set to 0."

I agree that there is no sane interpretation of RFC4443 that would lead to an ICMP response.

Now on a "link" with an *insane* switch that confuses layer 2 and layer 3 functions, something bad might happen. Is that what's going on here? If so, no fix to RFC4443 can solve the problem.

    Brian